package com.ocpsoft.pretty.util.el;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

import com.ocpsoft.pretty.config.mapping.PathParameter;

public class NamedInjectedParameterProcessor extends ExpressionProcessor
{
    public static final Pattern pattern = Pattern.compile("\\#\\{\\s*(\\w+)\\s*:\\s*([\\w\\.]{1,})\\s*\\}");

    @Override
    public PathParameter process(final String expression)
    {
        PathParameter result = null;

        Matcher matcher = pattern.matcher(expression);
        if (matcher.matches())
        {
            String name = matcher.group(1);
            String el = matcher.group(2);

            result = new PathParameter();
            result.setExpression("#{" + el + "}");
            result.setName(name);
        }
        return result;
    }

    /**
     * Remove all instances of this processors expression type from the given
     * URL.
     */

    @Override
    public Pattern getPattern()
    {
        return pattern;
    }
}
